diff --git a/src/backend/utils/adt/json.c b/src/backend/utils/adt/json.c
index 06dd62f0008..6316b7a4fab 100644
--- a/src/backend/utils/adt/json.c
+++ b/src/backend/utils/adt/json.c
@@ -606,7 +606,7 @@ add_json(Datum val, bool is_null, StringInfo result,
 	JsonTypeCategory tcategory;
 	Oid			outfuncoid;
 
-	if (val_type == InvalidOid)
+	if (!OidIsValid(val_type))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 				 errmsg("could not determine input data type")));
@@ -744,7 +744,7 @@ to_json(PG_FUNCTION_ARGS)
 	JsonTypeCategory tcategory;
 	Oid			outfuncoid;
 
-	if (val_type == InvalidOid)
+	if (!OidIsValid(val_type))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 				 errmsg("could not determine input data type")));
@@ -795,7 +795,7 @@ json_agg_transfn_worker(FunctionCallInfo fcinfo, bool absent_on_null)
 	{
 		Oid			arg_type = get_fn_expr_argtype(fcinfo->flinfo, 1);
 
-		if (arg_type == InvalidOid)
+		if (!OidIsValid(arg_type))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("could not determine input data type")));
@@ -1039,7 +1039,7 @@ json_object_agg_transfn_worker(FunctionCallInfo fcinfo,
 
 		arg_type = get_fn_expr_argtype(fcinfo->flinfo, 1);
 
-		if (arg_type == InvalidOid)
+		if (!OidIsValid(arg_type))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("could not determine data type for argument %d", 1)));
@@ -1049,7 +1049,7 @@ json_object_agg_transfn_worker(FunctionCallInfo fcinfo,
 
 		arg_type = get_fn_expr_argtype(fcinfo->flinfo, 2);
 
-		if (arg_type == InvalidOid)
+		if (!OidIsValid(arg_type))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("could not determine data type for argument %d", 2)));
diff --git a/src/backend/utils/adt/jsonb.c b/src/backend/utils/adt/jsonb.c
index 9399cdb491a..a9e21aa5008 100644
--- a/src/backend/utils/adt/jsonb.c
+++ b/src/backend/utils/adt/jsonb.c
@@ -1020,7 +1020,7 @@ add_jsonb(Datum val, bool is_null, JsonbInState *result,
 	JsonTypeCategory tcategory;
 	Oid			outfuncoid;
 
-	if (val_type == InvalidOid)
+	if (!OidIsValid(val_type))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 				 errmsg("could not determine input data type")));
@@ -1093,7 +1093,7 @@ to_jsonb(PG_FUNCTION_ARGS)
 	JsonTypeCategory tcategory;
 	Oid			outfuncoid;
 
-	if (val_type == InvalidOid)
+	if (!OidIsValid(val_type))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 				 errmsg("could not determine input data type")));
@@ -1525,7 +1525,7 @@ jsonb_agg_transfn_worker(FunctionCallInfo fcinfo, bool absent_on_null)
 	{
 		Oid			arg_type = get_fn_expr_argtype(fcinfo->flinfo, 1);
 
-		if (arg_type == InvalidOid)
+		if (!OidIsValid(arg_type))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("could not determine input data type")));
@@ -1713,7 +1713,7 @@ jsonb_object_agg_transfn_worker(FunctionCallInfo fcinfo,
 
 		arg_type = get_fn_expr_argtype(fcinfo->flinfo, 1);
 
-		if (arg_type == InvalidOid)
+		if (!OidIsValid(arg_type))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("could not determine input data type")));
@@ -1723,7 +1723,7 @@ jsonb_object_agg_transfn_worker(FunctionCallInfo fcinfo,
 
 		arg_type = get_fn_expr_argtype(fcinfo->flinfo, 2);
 
-		if (arg_type == InvalidOid)
+		if (!OidIsValid(arg_type))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("could not determine input data type")));
diff --git a/src/backend/utils/adt/like_support.c b/src/backend/utils/adt/like_support.c
index 999f23f86d5..5dbb2f57b4b 100644
--- a/src/backend/utils/adt/like_support.c
+++ b/src/backend/utils/adt/like_support.c
@@ -405,7 +405,7 @@ match_pattern_prefix(Node *leftop,
 	 *
 	 * expr_coll is not set for a non-collation-aware data type such as bytea.
 	 */
-	if (expr_coll && !get_collation_isdeterministic(expr_coll))
+	if (OidIsValid(expr_coll) && !get_collation_isdeterministic(expr_coll))
 		return NIL;
 
 	/*
diff --git a/src/backend/utils/adt/misc.c b/src/backend/utils/adt/misc.c
index a365c432d34..8d84efc42c3 100644
--- a/src/backend/utils/adt/misc.c
+++ b/src/backend/utils/adt/misc.c
@@ -284,7 +284,7 @@ pg_tablespace_databases(PG_FUNCTION_ARGS)
 		bool		nulls[1];
 
 		/* this test skips . and .., but is awfully weak */
-		if (!datOid)
+		if (!OidIsValid(datOid))
 			continue;
 
 		/* if database subdir is empty, don't report tablespace as used */
@@ -593,7 +593,7 @@ pg_collation_for(PG_FUNCTION_ARGS)
 	Oid			collid;
 
 	typeid = get_fn_expr_argtype(fcinfo->flinfo, 0);
-	if (!typeid)
+	if (!OidIsValid(typeid))
 		PG_RETURN_NULL();
 	if (!type_is_collatable(typeid) && typeid != UNKNOWNOID)
 		ereport(ERROR,
@@ -602,7 +602,7 @@ pg_collation_for(PG_FUNCTION_ARGS)
 						format_type_be(typeid))));
 
 	collid = PG_GET_COLLATION();
-	if (!collid)
+	if (!OidIsValid(collid))
 		PG_RETURN_NULL();
 	PG_RETURN_TEXT_P(cstring_to_text(generate_collation_name(collid)));
 }
@@ -761,7 +761,7 @@ pg_input_is_valid_common(FunctionCallInfo fcinfo,
 	 * If the typname argument is constant, we only need to parse it the first
 	 * time through.
 	 */
-	if (my_extra->typoid == InvalidOid || !my_extra->typname_constant)
+	if (!OidIsValid(my_extra->typoid) || !my_extra->typname_constant)
 	{
 		char	   *typnamestr = text_to_cstring(typname);
 		Oid			typoid;
diff --git a/src/backend/utils/adt/multirangetypes_selfuncs.c b/src/backend/utils/adt/multirangetypes_selfuncs.c
index 21f0205d803..d5cd6adc2bc 100644
--- a/src/backend/utils/adt/multirangetypes_selfuncs.c
+++ b/src/backend/utils/adt/multirangetypes_selfuncs.c
@@ -183,7 +183,7 @@ multirangesel(PG_FUNCTION_ARGS)
 	{
 		/* we have other Op var, commute to make var Op other */
 		operator = get_commutator(operator);
-		if (!operator)
+		if (!OidIsValid(operator))
 		{
 			/* Use default selectivity (should we raise an error instead?) */
 			ReleaseVariableStats(vardata);
diff --git a/src/backend/utils/adt/network.c b/src/backend/utils/adt/network.c
index 3cb0ab6829a..f0962aff0d1 100644
--- a/src/backend/utils/adt/network.c
+++ b/src/backend/utils/adt/network.c
@@ -1064,7 +1064,7 @@ match_network_subset(Node *leftop,
 	 * operator disallows equality.
 	 */
 	opr1oid = get_opfamily_member_for_cmptype(opfamily, datatype, datatype, is_eq ? COMPARE_GE : COMPARE_GT);
-	if (opr1oid == InvalidOid)
+	if (!OidIsValid(opr1oid))
 		return NIL;
 
 	opr1right = network_scan_first(rightopval);
@@ -1081,7 +1081,7 @@ match_network_subset(Node *leftop,
 	/* create clause "key <= network_scan_last( rightopval )" */
 
 	opr2oid = get_opfamily_member_for_cmptype(opfamily, datatype, datatype, COMPARE_LE);
-	if (opr2oid == InvalidOid)
+	if (!OidIsValid(opr2oid))
 		return NIL;
 
 	opr2right = network_scan_last(rightopval);
diff --git a/src/backend/utils/adt/pgstatfuncs.c b/src/backend/utils/adt/pgstatfuncs.c
index 1521d6e2ab4..5b8727349b0 100644
--- a/src/backend/utils/adt/pgstatfuncs.c
+++ b/src/backend/utils/adt/pgstatfuncs.c
@@ -380,14 +380,14 @@ pg_stat_get_activity(PG_FUNCTION_ARGS)
 			continue;
 
 		/* Values available to all callers */
-		if (beentry->st_databaseid != InvalidOid)
+		if (OidIsValid(beentry->st_databaseid))
 			values[0] = ObjectIdGetDatum(beentry->st_databaseid);
 		else
 			nulls[0] = true;
 
 		values[1] = Int32GetDatum(beentry->st_procpid);
 
-		if (beentry->st_userid != InvalidOid)
+		if (OidIsValid(beentry->st_userid))
 			values[2] = ObjectIdGetDatum(beentry->st_userid);
 		else
 			nulls[2] = true;
diff --git a/src/backend/utils/adt/rangetypes_selfuncs.c b/src/backend/utils/adt/rangetypes_selfuncs.c
index d85252cafb2..f112aac5b26 100644
--- a/src/backend/utils/adt/rangetypes_selfuncs.c
+++ b/src/backend/utils/adt/rangetypes_selfuncs.c
@@ -153,7 +153,7 @@ rangesel(PG_FUNCTION_ARGS)
 	{
 		/* we have other Op var, commute to make var Op other */
 		operator = get_commutator(operator);
-		if (!operator)
+		if (!OidIsValid(operator))
 		{
 			/* Use default selectivity (should we raise an error instead?) */
 			ReleaseVariableStats(vardata);
diff --git a/src/backend/utils/adt/regproc.c b/src/backend/utils/adt/regproc.c
index 7ce61efd947..22b0319abdf 100644
--- a/src/backend/utils/adt/regproc.c
+++ b/src/backend/utils/adt/regproc.c
@@ -555,7 +555,7 @@ regoperout(PG_FUNCTION_ARGS)
 	char	   *result;
 	HeapTuple	opertup;
 
-	if (oprid == InvalidOid)
+	if (!OidIsValid(oprid))
 	{
 		result = pstrdup("0");
 		PG_RETURN_CSTRING(result);
@@ -849,7 +849,7 @@ regoperatorout(PG_FUNCTION_ARGS)
 	Oid			oprid = PG_GETARG_OID(0);
 	char	   *result;
 
-	if (oprid == InvalidOid)
+	if (!OidIsValid(oprid))
 		result = pstrdup("0");
 	else
 		result = format_operator(oprid);
@@ -954,7 +954,7 @@ regclassout(PG_FUNCTION_ARGS)
 	char	   *result;
 	HeapTuple	classtup;
 
-	if (classid == InvalidOid)
+	if (!OidIsValid(classid))
 	{
 		result = pstrdup("-");
 		PG_RETURN_CSTRING(result);
@@ -1097,7 +1097,7 @@ regcollationout(PG_FUNCTION_ARGS)
 	char	   *result;
 	HeapTuple	collationtup;
 
-	if (collationid == InvalidOid)
+	if (!OidIsValid(collationid))
 	{
 		result = pstrdup("-");
 		PG_RETURN_CSTRING(result);
@@ -1258,7 +1258,7 @@ regtypeout(PG_FUNCTION_ARGS)
 	char	   *result;
 	HeapTuple	typetup;
 
-	if (typid == InvalidOid)
+	if (!OidIsValid(typid))
 	{
 		result = pstrdup("-");
 		PG_RETURN_CSTRING(result);
@@ -1370,7 +1370,7 @@ regconfigout(PG_FUNCTION_ARGS)
 	char	   *result;
 	HeapTuple	cfgtup;
 
-	if (cfgid == InvalidOid)
+	if (!OidIsValid(cfgid))
 	{
 		result = pstrdup("-");
 		PG_RETURN_CSTRING(result);
@@ -1480,7 +1480,7 @@ regdictionaryout(PG_FUNCTION_ARGS)
 	char	   *result;
 	HeapTuple	dicttup;
 
-	if (dictid == InvalidOid)
+	if (!OidIsValid(dictid))
 	{
 		result = pstrdup("-");
 		PG_RETURN_CSTRING(result);
@@ -1611,7 +1611,7 @@ regroleout(PG_FUNCTION_ARGS)
 	Oid			roleoid = PG_GETARG_OID(0);
 	char	   *result;
 
-	if (roleoid == InvalidOid)
+	if (!OidIsValid(roleoid))
 	{
 		result = pstrdup("-");
 		PG_RETURN_CSTRING(result);
@@ -1728,7 +1728,7 @@ regnamespaceout(PG_FUNCTION_ARGS)
 	Oid			nspid = PG_GETARG_OID(0);
 	char	   *result;
 
-	if (nspid == InvalidOid)
+	if (!OidIsValid(nspid))
 	{
 		result = pstrdup("-");
 		PG_RETURN_CSTRING(result);
@@ -1845,7 +1845,7 @@ regdatabaseout(PG_FUNCTION_ARGS)
 	Oid			dboid = PG_GETARG_OID(0);
 	char	   *result;
 
-	if (dboid == InvalidOid)
+	if (!OidIsValid(dboid))
 	{
 		result = pstrdup("-");
 		PG_RETURN_CSTRING(result);
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index 556ab057e5a..1e4f57bf245 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -10425,12 +10425,12 @@ get_rule_expr(Node *node, deparse_context *context,
 
 				context->varprefix = save_varprefix;
 
-				if (iexpr->infercollid)
+				if (OidIsValid(iexpr->infercollid))
 					appendStringInfo(buf, " COLLATE %s",
 									 generate_collation_name(iexpr->infercollid));
 
 				/* Add the operator class name, if not default */
-				if (iexpr->inferopclass)
+				if (OidIsValid(iexpr->inferopclass))
 				{
 					Oid			inferopclass = iexpr->inferopclass;
 					Oid			inferopcinputtype = get_opclass_input_type(iexpr->inferopclass);
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index 911376f79e8..6ea9b19fd27 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -1450,7 +1450,7 @@ scalarineqsel_wrapper(PG_FUNCTION_ARGS, bool isgt, bool iseq)
 	if (!varonleft)
 	{
 		operator = get_commutator(operator);
-		if (!operator)
+		if (!OidIsValid(operator))
 		{
 			/* Use default selectivity (should we raise an error instead?) */
 			ReleaseVariableStats(vardata);
@@ -2886,7 +2886,7 @@ neqjoinsel(PG_FUNCTION_ARGS)
 		 */
 		Oid			eqop = get_negator(operator);
 
-		if (eqop)
+		if (OidIsValid(eqop))
 		{
 			result =
 				DatumGetFloat8(DirectFunctionCall5Coll(eqjoinsel,
@@ -4338,7 +4338,7 @@ estimate_multivariate_ndistinct(PlannerInfo *root, RelOptInfo *rel,
 	}
 
 	/* No match? */
-	if (statOid == InvalidOid)
+	if (!OidIsValid(statOid))
 		return false;
 
 	Assert(nmatches_vars + nmatches_exprs > 1);
@@ -6116,7 +6116,7 @@ examine_indexcol_variable(PlannerInfo *root, IndexOptInfo *index,
 
 		Assert(rte->rtekind == RTE_RELATION);
 		relid = rte->relid;
-		Assert(relid != InvalidOid);
+		Assert(OidIsValid(relid));
 		colnum = index->indexkeys[indexcol];
 		vardata->rel = index->rel;
 
diff --git a/src/backend/utils/adt/varchar.c b/src/backend/utils/adt/varchar.c
index 3f40c9da1a0..6e3f4e6df7f 100644
--- a/src/backend/utils/adt/varchar.c
+++ b/src/backend/utils/adt/varchar.c
@@ -994,7 +994,7 @@ hashbpchar(PG_FUNCTION_ARGS)
 	pg_locale_t mylocale;
 	Datum		result;
 
-	if (!collid)
+	if (!OidIsValid(collid))
 		ereport(ERROR,
 				(errcode(ERRCODE_INDETERMINATE_COLLATION),
 				 errmsg("could not determine which collation to use for string hashing"),
@@ -1050,7 +1050,7 @@ hashbpcharextended(PG_FUNCTION_ARGS)
 	pg_locale_t mylocale;
 	Datum		result;
 
-	if (!collid)
+	if (!OidIsValid(collid))
 		ereport(ERROR,
 				(errcode(ERRCODE_INDETERMINATE_COLLATION),
 				 errmsg("could not determine which collation to use for string hashing"),
diff --git a/src/backend/utils/cache/inval.c b/src/backend/utils/cache/inval.c
index 02505c88b8e..25893fc0d78 100644
--- a/src/backend/utils/cache/inval.c
+++ b/src/backend/utils/cache/inval.c
@@ -647,7 +647,7 @@ RegisterRelcacheInvalidation(InvalidationInfo *info, Oid dbId, Oid relId)
 	 * invalidations for a specific database always invalidate the shared file
 	 * as well.  Also zap when we are invalidating whole relcache.
 	 */
-	if (relId == InvalidOid || RelationIdIsInInitFile(relId))
+	if (!OidIsValid(relId) || RelationIdIsInInitFile(relId))
 		info->RelcacheInitFileInval = true;
 }
 
@@ -824,7 +824,7 @@ LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg)
 {
 	if (msg->id >= 0)
 	{
-		if (msg->cc.dbId == MyDatabaseId || msg->cc.dbId == InvalidOid)
+		if (msg->cc.dbId == MyDatabaseId || !OidIsValid(msg->cc.dbId))
 		{
 			InvalidateCatalogSnapshot();
 
@@ -835,7 +835,7 @@ LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg)
 	}
 	else if (msg->id == SHAREDINVALCATALOG_ID)
 	{
-		if (msg->cat.dbId == MyDatabaseId || msg->cat.dbId == InvalidOid)
+		if (msg->cat.dbId == MyDatabaseId || !OidIsValid(msg->cat.dbId))
 		{
 			InvalidateCatalogSnapshot();
 
@@ -846,11 +846,11 @@ LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg)
 	}
 	else if (msg->id == SHAREDINVALRELCACHE_ID)
 	{
-		if (msg->rc.dbId == MyDatabaseId || msg->rc.dbId == InvalidOid)
+		if (msg->rc.dbId == MyDatabaseId || !OidIsValid(msg->rc.dbId))
 		{
 			int			i;
 
-			if (msg->rc.relId == InvalidOid)
+			if (!OidIsValid(msg->rc.relId))
 				RelationCacheInvalidate(false);
 			else
 				RelationCacheInvalidateEntry(msg->rc.relId);
@@ -878,7 +878,7 @@ LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg)
 	else if (msg->id == SHAREDINVALRELMAP_ID)
 	{
 		/* We only care about our own database and shared catalogs */
-		if (msg->rm.dbId == InvalidOid)
+		if (!OidIsValid(msg->rm.dbId))
 			RelationMapInvalidate(true);
 		else if (msg->rm.dbId == MyDatabaseId)
 			RelationMapInvalidate(false);
@@ -886,7 +886,7 @@ LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg)
 	else if (msg->id == SHAREDINVALSNAPSHOT_ID)
 	{
 		/* We only care about our own database and shared catalogs */
-		if (msg->sn.dbId == InvalidOid)
+		if (!OidIsValid(msg->sn.dbId))
 			InvalidateCatalogSnapshot();
 		else if (msg->sn.dbId == MyDatabaseId)
 			InvalidateCatalogSnapshot();
diff --git a/src/backend/utils/cache/lsyscache.c b/src/backend/utils/cache/lsyscache.c
index fa7cd7e06a7..1d2430d6233 100644
--- a/src/backend/utils/cache/lsyscache.c
+++ b/src/backend/utils/cache/lsyscache.c
@@ -3416,7 +3416,7 @@ get_attstatsslot(AttStatsSlot *sslot, HeapTuple statstuple,
 	for (i = 0; i < STATISTIC_NUM_SLOTS; i++)
 	{
 		if ((&stats->stakind1)[i] == reqkind &&
-			(reqop == InvalidOid || (&stats->staop1)[i] == reqop))
+			(!OidIsValid(reqop) || (&stats->staop1)[i] == reqop))
 			break;
 	}
 	if (i >= STATISTIC_NUM_SLOTS)
diff --git a/src/backend/utils/cache/plancache.c b/src/backend/utils/cache/plancache.c
index 6661d2c6b73..54772e6c260 100644
--- a/src/backend/utils/cache/plancache.c
+++ b/src/backend/utils/cache/plancache.c
@@ -2140,7 +2140,7 @@ PlanCacheRelCallback(Datum arg, Oid relid)
 		/*
 		 * Check the dependency list for the rewritten querytree.
 		 */
-		if ((relid == InvalidOid) ? plansource->relationOids != NIL :
+		if ((!OidIsValid(relid)) ? plansource->relationOids != NIL :
 			list_member_oid(plansource->relationOids, relid))
 		{
 			/* Invalidate the querytree and generic plan */
@@ -2163,7 +2163,7 @@ PlanCacheRelCallback(Datum arg, Oid relid)
 
 				if (plannedstmt->commandType == CMD_UTILITY)
 					continue;	/* Ignore utility statements */
-				if ((relid == InvalidOid) ? plannedstmt->relationOids != NIL :
+				if ((!OidIsValid(relid)) ? plannedstmt->relationOids != NIL :
 					list_member_oid(plannedstmt->relationOids, relid))
 				{
 					/* Invalidate the generic plan only */
@@ -2186,7 +2186,7 @@ PlanCacheRelCallback(Datum arg, Oid relid)
 		if (!cexpr->is_valid)
 			continue;
 
-		if ((relid == InvalidOid) ? cexpr->relationOids != NIL :
+		if ((!OidIsValid(relid)) ? cexpr->relationOids != NIL :
 			list_member_oid(cexpr->relationOids, relid))
 		{
 			cexpr->is_valid = false;
diff --git a/src/backend/utils/cache/relfilenumbermap.c b/src/backend/utils/cache/relfilenumbermap.c
index 0b6f9cf3fa1..3abd6f03282 100644
--- a/src/backend/utils/cache/relfilenumbermap.c
+++ b/src/backend/utils/cache/relfilenumbermap.c
@@ -65,8 +65,8 @@ RelfilenumberMapInvalidateCallback(Datum arg, Oid relid)
 		 * all entries, otherwise just remove the specific relation's entry.
 		 * Always remove negative cache entries.
 		 */
-		if (relid == InvalidOid ||	/* complete reset */
-			entry->relid == InvalidOid ||	/* negative cache entry */
+		if (!OidIsValid(relid) ||	/* complete reset */
+			!OidIsValid(entry->relid) ||	/* negative cache entry */
 			entry->relid == relid)	/* individual flushed relation */
 		{
 			if (hash_search(RelfilenumberMapHash,
diff --git a/src/backend/utils/cache/spccache.c b/src/backend/utils/cache/spccache.c
index 23458599298..657f1a8f9d3 100644
--- a/src/backend/utils/cache/spccache.c
+++ b/src/backend/utils/cache/spccache.c
@@ -114,7 +114,7 @@ get_tablespace(Oid spcid)
 	 * Since spcid is always from a pg_class tuple, InvalidOid implies the
 	 * default.
 	 */
-	if (spcid == InvalidOid)
+	if (!OidIsValid(spcid))
 		spcid = MyDatabaseTableSpace;
 
 	/* Find existing cache entry, if any. */
diff --git a/src/backend/utils/cache/ts_cache.c b/src/backend/utils/cache/ts_cache.c
index e8ae53238d0..4642d175d53 100644
--- a/src/backend/utils/cache/ts_cache.c
+++ b/src/backend/utils/cache/ts_cache.c
@@ -608,7 +608,7 @@ check_default_text_search_config(char **newval, void **extra, GucSource source)
 	 * cannot do the catalog accesses necessary to verify the config name.
 	 * Must accept it on faith.
 	 */
-	if (IsTransactionState() && MyDatabaseId != InvalidOid)
+	if (IsTransactionState() && OidIsValid(MyDatabaseId))
 	{
 		ErrorSaveContext escontext = {T_ErrorSaveContext};
 		List	   *namelist;
diff --git a/src/backend/utils/cache/typcache.c b/src/backend/utils/cache/typcache.c
index 6a347698edf..6757efbfb95 100644
--- a/src/backend/utils/cache/typcache.c
+++ b/src/backend/utils/cache/typcache.c
@@ -594,7 +594,7 @@ lookup_type_cache(Oid type_id, int flags)
 	 */
 	if ((flags & (TYPECACHE_EQ_OPR | TYPECACHE_EQ_OPR_FINFO)) &&
 		!(typentry->flags & TCFLAGS_CHECKED_EQ_OPR) &&
-		typentry->btree_opf == InvalidOid)
+		!OidIsValid(typentry->btree_opf))
 		flags |= TYPECACHE_HASH_OPFAMILY;
 
 	if ((flags & (TYPECACHE_HASH_PROC | TYPECACHE_HASH_PROC_FINFO |
@@ -634,13 +634,13 @@ lookup_type_cache(Oid type_id, int flags)
 	{
 		Oid			eq_opr = InvalidOid;
 
-		if (typentry->btree_opf != InvalidOid)
+		if (OidIsValid(typentry->btree_opf))
 			eq_opr = get_opfamily_member(typentry->btree_opf,
 										 typentry->btree_opintype,
 										 typentry->btree_opintype,
 										 BTEqualStrategyNumber);
-		if (eq_opr == InvalidOid &&
-			typentry->hash_opf != InvalidOid)
+		if (!OidIsValid(eq_opr) &&
+			OidIsValid(typentry->hash_opf))
 			eq_opr = get_opfamily_member(typentry->hash_opf,
 										 typentry->hash_opintype,
 										 typentry->hash_opintype,
@@ -681,7 +681,7 @@ lookup_type_cache(Oid type_id, int flags)
 	{
 		Oid			lt_opr = InvalidOid;
 
-		if (typentry->btree_opf != InvalidOid)
+		if (OidIsValid(typentry->btree_opf))
 			lt_opr = get_opfamily_member(typentry->btree_opf,
 										 typentry->btree_opintype,
 										 typentry->btree_opintype,
@@ -706,7 +706,7 @@ lookup_type_cache(Oid type_id, int flags)
 	{
 		Oid			gt_opr = InvalidOid;
 
-		if (typentry->btree_opf != InvalidOid)
+		if (OidIsValid(typentry->btree_opf))
 			gt_opr = get_opfamily_member(typentry->btree_opf,
 										 typentry->btree_opintype,
 										 typentry->btree_opintype,
@@ -731,7 +731,7 @@ lookup_type_cache(Oid type_id, int flags)
 	{
 		Oid			cmp_proc = InvalidOid;
 
-		if (typentry->btree_opf != InvalidOid)
+		if (OidIsValid(typentry->btree_opf))
 			cmp_proc = get_opfamily_proc(typentry->btree_opf,
 										 typentry->btree_opintype,
 										 typentry->btree_opintype,
@@ -764,7 +764,7 @@ lookup_type_cache(Oid type_id, int flags)
 		 * We insist that the eq_opr, if one has been determined, match the
 		 * hash opclass; else report there is no hash function.
 		 */
-		if (typentry->hash_opf != InvalidOid &&
+		if (OidIsValid(typentry->hash_opf) &&
 			(!OidIsValid(typentry->eq_opr) ||
 			 typentry->eq_opr == get_opfamily_member(typentry->hash_opf,
 													 typentry->hash_opintype,
@@ -813,7 +813,7 @@ lookup_type_cache(Oid type_id, int flags)
 		 * We insist that the eq_opr, if one has been determined, match the
 		 * hash opclass; else report there is no hash function.
 		 */
-		if (typentry->hash_opf != InvalidOid &&
+		if (OidIsValid(typentry->hash_opf) &&
 			(!OidIsValid(typentry->eq_opr) ||
 			 typentry->eq_opr == get_opfamily_member(typentry->hash_opf,
 													 typentry->hash_opintype,
@@ -866,33 +866,33 @@ lookup_type_cache(Oid type_id, int flags)
 	 * that would cause session-lifespan memory leaks.
 	 */
 	if ((flags & TYPECACHE_EQ_OPR_FINFO) &&
-		typentry->eq_opr_finfo.fn_oid == InvalidOid &&
-		typentry->eq_opr != InvalidOid)
+		!OidIsValid(typentry->eq_opr_finfo.fn_oid) &&
+		OidIsValid(typentry->eq_opr))
 	{
 		Oid			eq_opr_func;
 
 		eq_opr_func = get_opcode(typentry->eq_opr);
-		if (eq_opr_func != InvalidOid)
+		if (OidIsValid(eq_opr_func))
 			fmgr_info_cxt(eq_opr_func, &typentry->eq_opr_finfo,
 						  CacheMemoryContext);
 	}
 	if ((flags & TYPECACHE_CMP_PROC_FINFO) &&
-		typentry->cmp_proc_finfo.fn_oid == InvalidOid &&
-		typentry->cmp_proc != InvalidOid)
+		!OidIsValid(typentry->cmp_proc_finfo.fn_oid) &&
+		OidIsValid(typentry->cmp_proc))
 	{
 		fmgr_info_cxt(typentry->cmp_proc, &typentry->cmp_proc_finfo,
 					  CacheMemoryContext);
 	}
 	if ((flags & TYPECACHE_HASH_PROC_FINFO) &&
-		typentry->hash_proc_finfo.fn_oid == InvalidOid &&
-		typentry->hash_proc != InvalidOid)
+		!OidIsValid(typentry->hash_proc_finfo.fn_oid) &&
+		OidIsValid(typentry->hash_proc))
 	{
 		fmgr_info_cxt(typentry->hash_proc, &typentry->hash_proc_finfo,
 					  CacheMemoryContext);
 	}
 	if ((flags & TYPECACHE_HASH_EXTENDED_PROC_FINFO) &&
-		typentry->hash_extended_proc_finfo.fn_oid == InvalidOid &&
-		typentry->hash_extended_proc != InvalidOid)
+		!OidIsValid(typentry->hash_extended_proc_finfo.fn_oid) &&
+		OidIsValid(typentry->hash_extended_proc))
 	{
 		fmgr_info_cxt(typentry->hash_extended_proc,
 					  &typentry->hash_extended_proc_finfo,
@@ -938,7 +938,7 @@ lookup_type_cache(Oid type_id, int flags)
 	 * If requested, get information about a domain type
 	 */
 	if ((flags & TYPECACHE_DOMAIN_BASE_INFO) &&
-		typentry->domainBaseType == InvalidOid &&
+		!OidIsValid(typentry->domainBaseType) &&
 		typentry->typtype == TYPTYPE_DOMAIN)
 	{
 		typentry->domainBaseTypmod = -1;
@@ -1678,7 +1678,7 @@ cache_record_field_properties(TypeCacheEntry *typentry)
 		TypeCacheEntry *baseentry;
 
 		/* load up basetype info if we didn't already */
-		if (typentry->domainBaseType == InvalidOid)
+		if (!OidIsValid(typentry->domainBaseType))
 		{
 			typentry->domainBaseTypmod = -1;
 			typentry->domainBaseType =
diff --git a/src/backend/utils/fmgr/funcapi.c b/src/backend/utils/fmgr/funcapi.c
index 5f2317211c9..98b88b12231 100644
--- a/src/backend/utils/fmgr/funcapi.c
+++ b/src/backend/utils/fmgr/funcapi.c
@@ -490,7 +490,7 @@ internal_get_result_type(Oid funcid,
 	{
 		Oid			newrettype = exprType(call_expr);
 
-		if (newrettype == InvalidOid)	/* this probably should not happen */
+		if (!OidIsValid(newrettype))	/* this probably should not happen */
 			ereport(ERROR,
 					(errcode(ERRCODE_DATATYPE_MISMATCH),
 					 errmsg("could not determine actual result type for function \"%s\" declared to return type %s",
diff --git a/src/backend/utils/misc/queryenvironment.c b/src/backend/utils/misc/queryenvironment.c
index 7bc72dabe67..8ae1783bc0e 100644
--- a/src/backend/utils/misc/queryenvironment.c
+++ b/src/backend/utils/misc/queryenvironment.c
@@ -127,7 +127,7 @@ ENRMetadataGetTupDesc(EphemeralNamedRelationMetadata enrmd)
 	TupleDesc	tupdesc;
 
 	/* One, and only one, of these fields must be filled. */
-	Assert((enrmd->reliddesc == InvalidOid) != (enrmd->tupdesc == NULL));
+	Assert((!OidIsValid(enrmd->reliddesc)) != (enrmd->tupdesc == NULL));
 
 	if (enrmd->tupdesc != NULL)
 		tupdesc = enrmd->tupdesc;
diff --git a/src/bin/pg_dump/common.c b/src/bin/pg_dump/common.c
index 4e7303ea631..bc1d3a7adc8 100644
--- a/src/bin/pg_dump/common.c
+++ b/src/bin/pg_dump/common.c
@@ -402,7 +402,7 @@ flagInhIndexes(Archive *fout, TableInfo tblinfo[], int numTables)
 			IndxInfo   *parentidx;
 			IndexAttachInfo *attachinfo;
 
-			if (index->parentidx == 0)
+			if (!OidIsValid(index->parentidx))
 				continue;
 
 			parentidx = findIndexByOid(index->parentidx);
diff --git a/src/bin/pg_dump/pg_backup_archiver.c b/src/bin/pg_dump/pg_backup_archiver.c
index c84b017f21b..0122ec6239d 100644
--- a/src/bin/pg_dump/pg_backup_archiver.c
+++ b/src/bin/pg_dump/pg_backup_archiver.c
@@ -1518,7 +1518,7 @@ StartRestoreLO(ArchiveHandle *AH, Oid oid, bool drop)
 		if (old_lo_style)
 		{
 			loOid = lo_create(AH->connection, oid);
-			if (loOid == 0 || loOid != oid)
+			if (!OidIsValid(loOid) || loOid != oid)
 				pg_fatal("could not create large object %u: %s",
 						 oid, PQerrorMessage(AH->connection));
 		}
diff --git a/src/bin/pg_dump/pg_backup_custom.c b/src/bin/pg_dump/pg_backup_custom.c
index 2226520dffc..d2ea2397181 100644
--- a/src/bin/pg_dump/pg_backup_custom.c
+++ b/src/bin/pg_dump/pg_backup_custom.c
@@ -371,7 +371,7 @@ _StartLO(ArchiveHandle *AH, TocEntry *te, Oid oid)
 {
 	lclContext *ctx = (lclContext *) AH->formatData;
 
-	if (oid == 0)
+	if (!OidIsValid(oid))
 		pg_fatal("invalid OID for large object");
 
 	WriteInt(AH, oid);
@@ -583,7 +583,7 @@ _LoadLOs(ArchiveHandle *AH, bool drop)
 	StartRestoreLOs(AH);
 
 	oid = ReadInt(AH);
-	while (oid != 0)
+	while (OidIsValid(oid))
 	{
 		StartRestoreLO(AH, oid, drop);
 		_PrintData(AH);
@@ -606,7 +606,7 @@ _skipLOs(ArchiveHandle *AH)
 	Oid			oid;
 
 	oid = ReadInt(AH);
-	while (oid != 0)
+	while (OidIsValid(oid))
 	{
 		_skipData(AH);
 		oid = ReadInt(AH);
diff --git a/src/bin/pg_dump/pg_backup_null.c b/src/bin/pg_dump/pg_backup_null.c
index a3257f4fc84..a3bc2f93605 100644
--- a/src/bin/pg_dump/pg_backup_null.c
+++ b/src/bin/pg_dump/pg_backup_null.c
@@ -139,7 +139,7 @@ _StartLO(ArchiveHandle *AH, TocEntry *te, Oid oid)
 {
 	bool		old_lo_style = (AH->version < K_VERS_1_12);
 
-	if (oid == 0)
+	if (!OidIsValid(oid))
 		pg_fatal("invalid OID for large object");
 
 	/* With an old archive we must do drop and create logic here */
diff --git a/src/bin/pg_dump/pg_backup_tar.c b/src/bin/pg_dump/pg_backup_tar.c
index b5ba3b46dd9..991ec51137e 100644
--- a/src/bin/pg_dump/pg_backup_tar.c
+++ b/src/bin/pg_dump/pg_backup_tar.c
@@ -678,7 +678,7 @@ _LoadLOs(ArchiveHandle *AH, TocEntry *te)
 		if (strncmp(th->targetFile, "blob_", 5) == 0)
 		{
 			oid = atooid(&th->targetFile[5]);
-			if (oid != 0)
+			if (OidIsValid(oid))
 			{
 				pg_log_info("restoring large object with OID %u", oid);
 
@@ -899,7 +899,7 @@ _StartLO(ArchiveHandle *AH, TocEntry *te, Oid oid)
 	lclTocEntry *tctx = (lclTocEntry *) te->formatData;
 	char		fname[255];
 
-	if (oid == 0)
+	if (!OidIsValid(oid))
 		pg_fatal("invalid OID for large object (%u)", oid);
 
 	if (AH->compression_spec.algorithm != PG_COMPRESSION_NONE)
